summaryrefslogtreecommitdiff
path: root/TAO/orbsvcs/DevGuideExamples/NotifyService/QoSProperties/run_test.pl
diff options
context:
space:
mode:
Diffstat (limited to 'TAO/orbsvcs/DevGuideExamples/NotifyService/QoSProperties/run_test.pl')
-rwxr-xr-xTAO/orbsvcs/DevGuideExamples/NotifyService/QoSProperties/run_test.pl229
1 files changed, 177 insertions, 52 deletions
diff --git a/TAO/orbsvcs/DevGuideExamples/NotifyService/QoSProperties/run_test.pl b/TAO/orbsvcs/DevGuideExamples/NotifyService/QoSProperties/run_test.pl
index b787dd9f8c8..737f4ab9046 100755
--- a/TAO/orbsvcs/DevGuideExamples/NotifyService/QoSProperties/run_test.pl
+++ b/TAO/orbsvcs/DevGuideExamples/NotifyService/QoSProperties/run_test.pl
@@ -4,74 +4,199 @@ eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
& eval 'exec perl -S $0 $argv:q'
if 0;
-use Env (ACE_ROOT);
-use lib "$ACE_ROOT/bin";
-use PerlACE::Run_Test;
-
-$nsiorfile = PerlACE::LocalFile("ns.ior");
-$messiorfile = PerlACE::LocalFile("Messenger.ior");
-$notify_ior = PerlACE::LocalFile("notify.ior");
-$arg_ns_ref = "-ORBInitRef NameService=file://$nsiorfile";
-unlink $nsiorfile;
-unlink $messiorfile;
-unlink $notify_ior;
+use lib "$ENV{ACE_ROOT}/bin";
+use PerlACE::TestTarget;
+
+$status = 0;
+$debug_level = '0';
+
+foreach $i (@ARGV) {
+ if ($i eq '-debug') {
+ $debug_level = '10';
+ }
+}
+
+my $ns = PerlACE::TestTarget::create_target (1) || die "Create target 1 failed\n";
+my $nfs = PerlACE::TestTarget::create_target (2) || die "Create target 2 failed\n";
+my $srv = PerlACE::TestTarget::create_target (3) || die "Create target 3 failed\n";
+my $con = PerlACE::TestTarget::create_target (4) || die "Create target 4 failed\n";
+my $cli = PerlACE::TestTarget::create_target (5) || die "Create target 5 failed\n";
+
+$nsiorfile = "ns.ior";
+$srviorfile = "Messenger.ior";
+$nfsiorfile = "notify.ior";
+
+my $ns_nsiorfile = $ns->LocalFile ($nsiorfile);
+my $nfs_nsiorfile = $nfs->LocalFile ($nsiorfile);
+my $srv_nsiorfile = $srv->LocalFile ($nsiorfile);
+my $con_nsiorfile = $con->LocalFile ($nsiorfile);
+my $cli_nsiorfile = $cli->LocalFile ($nsiorfile);
+my $nfs_nfsiorfile = $nfs->LocalFile ($nfsiorfile);
+my $srv_srviorfile = $srv->LocalFile ($srviorfile);
+my $cli_srviorfile = $cli->LocalFile ($srviorfile);
+$ns->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nsiorfile);
+$srv->DeleteFile ($nsiorfile);
+$con->DeleteFile ($nsiorfile);
+$cli->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nfsiorfile);
+$srv->DeleteFile ($srviorfile);
+$cli->DeleteFile ($srviorfile);
-# start Naming Service
$NameService = "$ENV{TAO_ROOT}/orbsvcs/Naming_Service/Naming_Service";
-$NS = new PerlACE::Process($NameService, "-o $nsiorfile");
-$NS->Spawn();
-if (PerlACE::waitforfile_timed ($nsiorfile, 10) == -1) {
- print STDERR "ERROR: cannot find file $nsiorfile\n";
- $NS->Kill();
+$NS = $ns->CreateProcess ($NameService, " -o $ns_nsiorfile");
+
+
+$NotifyService = "$ENV{TAO_ROOT}/orbsvcs/Notify_Service/Notify_Service";
+$NFS = $nfs->CreateProcess ($NotifyService, "-ORBInitRef NameService=file://$nfs_nsiorfile ".
+ "-IORoutput $nfs_nfsiorfile");
+$SRV = $srv->CreateProcess ("MessengerServer", "-ORBdebuglevel $debug_level ".
+ "-o $srv_srviorfile ".
+ "-ORBInitRef NameService=file://$srv_nsiorfile");
+$CON = $con->CreateProcess ("MessengerConsumer", "-ORBInitRef NameService=file://$con_nsiorfile");
+$CLI = $cli->CreateProcess ("MessengerClient", "-ORBInitRef NameService=file://$cli_nsiorfile ".
+ "-k file://$cli_srviorfile");
+
+# start Naming Service
+$NS_status = $NS->Spawn ();
+
+if ($NS_status != 0) {
+ print STDERR "ERROR: Name Service returned $NS_status\n";
+ exit 1;
+}
+
+if ($ns->WaitForFileTimed ($nsiorfile,$ns->ProcessStartWaitInterval()) == -1) {
+ print STDERR "ERROR: cannot find file <$ns_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+
+if ($ns->GetFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot retrieve file <$ns_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+if ($nfs->PutFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$nfs_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+if ($srv->PutFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$srv_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+if ($con->PutFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$con_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+if ($cli->PutFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$cli_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
exit 1;
}
# start Notification Service
+$NFS_status = $NFS->Spawn ();
-$NotifyService = "$ENV{TAO_ROOT}/orbsvcs/Notify_Service/Notify_Service";
-$NFS = new PerlACE::Process($NotifyService, "$arg_ns_ref -IORoutput $notify_ior");
-$NFS->Spawn();
-# the ior file is only used to wait for the service to start
-if (PerlACE::waitforfile_timed ($notify_ior, 10) == -1) {
- print STDERR "ERROR: Timed out waiting for $notify_ior\n";
- $NS->Kill ();
- $NFS->Kill ();
- exit 1;
+if ($NFS_status != 0) {
+ print STDERR "ERROR: Notify Service returned $NFS_status\n";
+ exit 1;
+}
+
+if ($nfs->WaitForFileTimed ($nfsiorfile,$nfs->ProcessStartWaitInterval()) == -1) {
+ print STDERR "ERROR: cannot find file <$nfs_nfsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
}
# start MessengerServer
-$S = new PerlACE::Process("MessengerServer", $arg_ns_ref);
-$S->Spawn();
+$SRV_status = $SRV->Spawn ();
+
+if ($SRV_status != 0) {
+ print STDERR "ERROR: Server returned $SRV_status\n";
+ exit 1;
+}
-# Wait for the MessengerServer
-if (PerlACE::waitforfile_timed ($messiorfile, 10) == -1) {
- print STDERR "ERROR: Timed out waiting for $messiorfile\n";
- $S->Kill();
- $NS->Kill ();
- $NFS->Kill ();
- exit 1;
+if ($srv->WaitForFileTimed ($srviorfile,$srv->ProcessStartWaitInterval()) == -1) {
+ print STDERR "ERROR: cannot find file <$srv_srviorfile>\n";
+ $SRV->Kill (); $SRV->TimedWait (1);
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
+}
+
+if ($srv->GetFile ($srviorfile) == -1) {
+ print STDERR "ERROR: cannot retrieve file <$srv_srviorfile>\n";
+ $SRV->Kill (); $SRV->TimedWait (1);
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
}
+if ($cli->PutFile ($srviorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$cli_srviorfile>\n";
+ $SRV->Kill (); $SRV->TimedWait (1);
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
+}
+
# start MessengerConsumer
-$MC = new PerlACE::Process("MessengerConsumer", $arg_ns_ref);
-$MC->Spawn();
+$CON_status = $CON->Spawn ();
+
+if ($CON_status != 0) {
+ print STDERR "ERROR: Consumer returned $CON_status\n";
+ exit 1;
+}
# start MessengerClient
-$C = new PerlACE::Process("MessengerClient", $arg_ns_ref);
-if ($C->SpawnWaitKill(10) != 0) {
- $MC->Kill();
- $S->Kill();
- $NFS->Kill();
- $NS->Kill();
- exit (1);
+$CLI_status = $CLI->SpawnWaitKill ($cli->ProcessStartWaitInterval());
+
+if ($CLI_status != 0) {
+ print STDERR "ERROR: Messenger Client returned $CLI_status\n";
+ $CON->Kill (); $CON->TimedWait (1);
+ $SRV->Kill (); $SRV->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ $NS->Kill (); $NS->TimedWait (1);
+ $status = 1;
+}
+
+$CON_status = $CON->TerminateWaitKill ($con->ProcessStopWaitInterval());
+
+if ($CON_status != 0) {
+ print STDERR "ERROR: Messenger Consumer returned $CON_status\n";
+ $status = 1;
}
-$MC->Kill();
-$S->Kill();
-$NFS->Kill();
-$NS->Kill();
+$SRV_status = $SRV->TerminateWaitKill ($srv->ProcessStopWaitInterval());
+
+if ($SRV_status != 0) {
+ print STDERR "ERROR: Messenger Server returned $SRV_status\n";
+ $status = 1;
+}
+$NFS_status = $NFS->TerminateWaitKill ($nfs->ProcessStopWaitInterval());
+
+if ($NFS_status != 0) {
+ print STDERR "ERROR: Notification Service returned $NFS_status\n";
+ $status = 1;
+}
+
+$NS_status = $NS->TerminateWaitKill ($ns->ProcessStopWaitInterval());
+
+if ($NS_status != 0) {
+ print STDERR "ERROR: Name Service returned $NS_status\n";
+ $status = 1;
+}
-unlink $nsiorfile;
-unlink $messiorfile;
-unlink $notify_ior;
+$ns->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nsiorfile);
+$srv->DeleteFile ($nsiorfile);
+$con->DeleteFile ($nsiorfile);
+$cli->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nfsiorfile);
+$srv->DeleteFile ($srviorfile);
+$cli->DeleteFile ($srviorfile);
-exit 0;
+exit $status;